// ==============================================================
//	This file is part of Glest (www.glest.org)
//
//	Copyright (C) 2001-2005 Martio Figueroa
//
//	You can redistribute this code and/or modify it under 
//	the terms of the GNU General Public License as published 
//	by the Free Software Foundation; either version 2 of the 
//	License, or (at your option) any later version
// ==============================================================

#include "game_util.h"

#include "util.h"
#include "lang.h"
#include "leak_dumper.h"

using namespace Shared::Util;

namespace Glest{ namespace Game{

const string mailString= "game@glest.org";
const string glestVersionString= "v1.1.0-rc6";

string getAboutString(int i){
	switch(i){
	case 0: return "Glest " + glestVersionString;
	case 1: return "Built: " + string( __DATE__);
	case 2: return "Shared Library " + sharedLibVersionString;
	case 3: return "Copyright 2001-2005 The Glest Team";
	case 4: return "";
	case 5: return "Web: http://www.glest.org";
	case 6: return "Mail: " + mailString;
	}
	return "";
}

string getTeammateName(int i){
	Lang &l= Lang::getInstance();

	switch(i){
	case 0: return "Martio Figueroa";
	case 1: return "Jos Luis Gonzlez";
	case 2: return "Tucho Fernndez";
	case 3: return "Jos Zanni";
	case 4: return "Marcos Caruncho";
	}
	return "";
}

string getTeammateRole(int i){
	Lang &l= Lang::getInstance();

	switch(i){
	case 0: return l.get("Programming");
	case 1: return l.get("SoundAndMusic");
	case 2: return l.get("3dAnd2dArt");
	case 3: return l.get("2dArtAndWeb");
	case 4: return l.get("3dArt");
	}
	return "";
}

string formatString(const string &str){
	string outStr = str;

	if(!outStr.empty()){
		outStr[0]= toupper(outStr[0]);
	}

	bool afterSeparator= false;
	for(int i= 0; i<str.size(); ++i){
		if(outStr[i]=='_'){
			outStr[i]= ' ';
		}
		else if(afterSeparator){
			outStr[i]= toupper(outStr[i]);
			afterSeparator= false;
		}
		if(outStr[i]=='\n' || outStr[i]=='(' || outStr[i]==' '){
			afterSeparator= true;
		}
	}
	return outStr;
}

}}//end namespace
