// ==============================================================
//	This file is part of Glest Shared Library (www.glest.org)
//
//	Copyright (C) 2001-2005 Martio Figueroa
//
//	You can redistribute this code and/or modify it under 
//	the terms of the GNU General Public License as published 
//	by the Free Software Foundation; either version 2 of the 
//	License, or (at your option) any later version
// ==============================================================

#include "context_gl.h"

#include <cassert>
#include <stdexcept>

#include "opengl.h"
#include "shader_gl.h"
#include "leak_dumper.h"

using namespace std;

namespace Shared{ namespace Graphics{ namespace Gl{

// ===============================================
//	class ContextGl
// ===============================================

void ContextGl::init(WindowHandle windowHandle){
	pcgl.init(windowHandle, colorBits, depthBits, stencilBits);
}

void ContextGl::end(){
	pcgl.end();
}

void ContextGl::makeCurrent(){
	pcgl.makeCurrent();
}

void ContextGl::swapBuffers(){
	pcgl.swapBuffers();
}

void ContextGl::setShaderProgram(ShaderProgram *sp){
	sp->activate();
}

void ContextGl::disableShaders(){
	assertGl();
	glUseProgramObjectARB(0);
	assertGl();
}

}}}//end namespace
